/*
    Aufgabe 5) Eindimensionale Arrays und File I/O
*/

import codedraw.CodeDraw;
import codedraw.textformat.HorizontalAlign;
import codedraw.textformat.TextFormat;

import java.awt.*;
import java.util.Arrays;
import java.util.Scanner;
import java.io.FileReader;
import java.io.IOException;

public class Aufgabe5 {

    //Ich kann sonst nicht dynamisch bei der Methode drawChart das Jahr schreiben lassen
    //Klassenvariablen sind ohnehin nicht verboten bei diesem Aufgabenblatt
    private static int startYear = 0;

    private static String[] readFileData(String fileName, int firstLine, int lastLine) {

        if (fileName != "" && lastLine >= firstLine) {
            firstLine-=1;
            lastLine-=1;
            String[] textLines = new String[lastLine - firstLine + 1];
            int lineIndex = 0;
            String tempLine;

            try {
                Scanner inputStream = new Scanner(new FileReader("./src/" + fileName));
                //TODO: Implementieren Sie hier die Schleife für das Einlesen der Daten
                for (int i = 0; i < firstLine; i++) {
                    inputStream.nextLine();
                }
                while (textLines.length > lineIndex && inputStream.hasNextLine()) {
                    tempLine = inputStream.nextLine();
                    textLines[lineIndex] = tempLine;
                    lineIndex++;
                }
                inputStream.close();
            } catch (IOException e) {
                System.out.println("File... " + System.getProperty("user.dir") + "\\src\\" + fileName + " not found!");
                System.exit(1);
            }

            return textLines;
        }

        return null;
    }

    private static void extractData(String[] dataArray, int[] resultArray, int indexColumn, int entriesPerYear) {
        //TODO: Implementieren Sie hier Ihre Lösung für die Angabe
        if (indexColumn > 0 && entriesPerYear > 0 && dataArray.length > 0 && resultArray.length >= dataArray.length/entriesPerYear) {
            int month = 1;
            int yearIndex = 0;
            startYear = (Integer.valueOf(dataArray[0].split(";")[0]) / 100) % 100;
            System.out.println(startYear);
            for (int i = 0; i < dataArray.length; i++) {
                resultArray[yearIndex] += Integer.valueOf(dataArray[i].split(";")[indexColumn]);

                System.out.println(Integer.valueOf(dataArray[i].split(";")[0]) + " " + yearIndex);
                if (month >= entriesPerYear) {
                    yearIndex++;
                    month = 1;
                } else
                    month++;
            }
        }
    }

    private static void drawChart(CodeDraw myDrawObj, int[] iceDays) {

        if (iceDays.length > 0 && myDrawObj != null) {
            TextFormat format = myDrawObj.getTextFormat();
            format.setFontSize(10);
            format.setHorizontalAlign(HorizontalAlign.CENTER);

            int mid = 0;
            for (int i = 0; i < iceDays.length; i++) {
                mid += iceDays[i];
            }
            mid /= iceDays.length;

            for (int i = 0; i < iceDays.length; i++) {
                //Rectangle
                if (iceDays[i] >= mid) myDrawObj.setColor(Color.blue);
                else myDrawObj.setColor(Color.cyan);
                myDrawObj.fillRectangle(15 + 25 * i, myDrawObj.getHeight() - iceDays[i] * 10, 20, iceDays[i] * 10);

                //Year
                if (iceDays[i] >= mid) myDrawObj.setColor(Color.white);
                else myDrawObj.setColor(Color.black);
                myDrawObj.drawText(25 + 25 * i, myDrawObj.getHeight() - 10, String.format("%02d", (startYear + i) % 100));

                //Icedays
                myDrawObj.setColor(Color.black);
                myDrawObj.drawText(25 + 25 * i, myDrawObj.getHeight() - iceDays[i] * 10 - 10, String.valueOf(iceDays[i]));
            }
            myDrawObj.show();
        }

        //TODO: Implementieren Sie hier Ihre Lösung für die Angabe
    }

    public static void main(String[] args) {

        int width = 1300;
        int height = 525;
        CodeDraw myDrawObj = new CodeDraw(width, height);
        myDrawObj.setTitle("Ergebnis Wetterdaten - EISTAGE");
        //Wenn nicht genau 51 Einträge in Zeilen selektiert werden kann es nicht auf beiden Seiten zum Rand 15px Abstand sein
        String[] data = readFileData("weather_data.csv", 182,793);
        int[] iceDaysData = new int[data.length/12];
        extractData(data,iceDaysData,12,12);
        System.out.println(Arrays.toString(iceDaysData));
        drawChart(myDrawObj,iceDaysData);

        //TODO: Implementieren Sie hier Ihre Lösung für die Angabe
    }
}
